<script>
export default {
  props: {
    data: {
      required: true,
      type: Object,
    },
    isOpen: {
      required: true,
      type: Boolean,
    },
    isWhite: {
      required: false,
      type: Boolean,
      default: false,
    },
  },
  computed: {
    accordionID() {
      return this.data.header.toLowerCase().split(' ').join('');
    },
  },
  methods: {
    toggleAccordion() {
      this.$emit('toggleController');
    },
  },
};
</script>

<template>
  <div
    class="accordion"
    data-inbound-analytics="public-sector-leap-target"
    :data-toggle-group="data.header"
    :data-ga-toggle="isOpen ? 'expand' : 'collapse'"
  >
    <SlpTypography
      tag="h3"
      variant="heading5-bold"
      class="summary"
      @click.native="toggleAccordion"
    >
      <button
        :id="accordionID + 'id'"
        class="accordion__button"
        :aria-expanded="`${isOpen}`"
        :aria-controls="accordionID + 'section'"
      >
        <SlpIcon
          v-if="data.icon"
          class="slp-mr-16"
          :name="data.icon.name"
          :alt="data.icon.alt"
          :variant="data.icon.variant"
          :hex-color="data.icon.hex_color"
          size="md"
        />
        <span class="accordion__header">{{ data.header }}</span>
        <span
          class="accordion__icon"
          :class="{ 'accordion__icon--open': isOpen }"
        ></span>
      </button>
    </SlpTypography>

    <div
      v-show="isOpen"
      :id="accordionID + 'section'"
      class="content-container"
      :class="{ 'accordion--white': isWhite }"
      role="region"
      :aria-labelledby="accordionID + 'id'"
    >
      <div class="content" v-html="$md.render(data.text)"></div>
      <slot name="additional-content"></slot>
      <SlpButton
        v-if="data.link_url"
        :href="data.link_url"
        variant="tertiary"
        :class="{ 'accordion__button--white': isWhite }"
        :data-ga-name="data.ga_name || 'learn more'"
        :data-ga-location="data.ga_location || 'benefits'"
        ><span>{{ data.link_text || $t('learnMore') }}</span>
        <SlpIcon
          class="slp-ml-8"
          name="chevron-lg-right"
          variant="product"
          alt="Chevron Right Icon"
        />
      </SlpButton>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.accordion {
  color: $color-text-300;
  list-style-type: none;
  overflow: hidden;
  width: 100%;
  text-align: left;

  &:first-of-type {
    border-radius: 3px 3px 0 0;
    border-top-width: 1px;
  }

  .summary {
    cursor: pointer;
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding-top: $spacing-16;
    padding-bottom: 20px;
    border-top: 1px solid $color-surface-300;
  }

  .content-container {
    text-align: left;
    padding: 0 0 $spacing-32 0;
    font-size: $text-body-1;
    line-height: $line-height-default;

    .slp-btn-tertiary {
      padding-left: 0;
      -webkit-text-decoration: underline;
      text-decoration: underline;
      text-underline-offset: 2px;
      text-decoration-color: transparent;
      -webkit-text-decoration: none;
      transition: all 0.2s ease-in-out;

      &:hover {
        text-decoration-color: #171321;
        -webkit-text-decoration: underline;
        text-decoration: underline;
      }
    }

    a {
      display: flex;
      align-items: center;
      font-weight: $font-weight-bold;
      color: $color-text-300;

      svg {
        margin-left: 4px;
        &:hover {
          transform: translateX(8px);
        }
      }
    }
  }

  .content :deep {
    p,
    li,
    a {
      font-size: $font-size-default;
      line-height: $line-height-default;
      margin-bottom: $spacing-16;
    }
  }
  &__icon {
    height: 18px;
    width: 18px;
    position: relative;
    transition: transform 0.4s ease-in-out;
    margin-left: $spacing-4;
    &--open {
      transform: rotate(90deg);
      &:after {
        opacity: 0;
      }
    }
    &:before,
    &:after {
      content: '';
      background-color: black;
      position: absolute;
      display: block;
    }
    &:before {
      height: 18px;
      width: 2px;
      left: 50%;
    }
    &:after {
      height: 18px;
      width: 2px;
      transform: rotate(-90deg);
      top: 50%;
      transform-origin: top;
      transition: opacity 0.3s ease-in-out;
    }
  }
  &__button {
    border: 0;
    cursor: pointer;
    display: flex;
    padding: 0;
    width: 100%;
    align-items: center;
    font-weight: $font-weight-bold;
    margin-top: $spacing-4;

    &--white {
      color: $color-text-50 !important;
    }
  }

  &__header {
    color: $color-secondary-300;
    flex: 1;
    font-weight: $font-weight-bold !important;
    text-align: left;
  }
}
</style>
